commit b5d386495b3f8e638acaab3f7f2ada2c7a3d0f55
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Wed May 28 16:19:18 2025

    libstdc++: Make system_clock::to_time_t always_inline [PR99832]
    
    For some 32-bit targets Glibc supports changing the size of time_t to be
    64 bits by defining _TIME_BITS=64. That causes an ABI change which
    would affect std::chrono::system_clock::to_time_t. Because to_time_t is
    not a function template, its mangled name does not depend on the return
    type, so it has the same mangled name whether it returns a 32-bit time_t
    or a 64-bit time_t. On targets where the size of time_t can be selected
    at preprocessing time, that can cause ODR violations, e.g. the linker
    selects a definition of to_time_t that returns a 32-bit value but a
    caller expects 64-bit and so reads 32 bits of garbage from the stack.
    
    This commit adds always_inline to to_time_t so that all callers inline
    the conversion to time_t, and will do so using whatever type time_t
    happens to be in that translation unit.
    
    Existing objects compiled before this change will either have inlined
    the function anyway (which is likely if compiled with any optimization
    enabled) or will contain a COMDAT definition of the inline function and
    so still be able to find it at link-time.
    
    The attribute is also added to system_clock::from_time_t, because that's
    an equally simple function and it seems reasonable for them to both be
    always inlined.
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/99832
            * include/bits/chrono.h (system_clock::to_time_t): Add
            always_inline attribute to be agnostic to the underlying type of
            time_t.
            (system_clock::from_time_t): Add always_inline for consistency
            with to_time_t.
            * testsuite/20_util/system_clock/99832.cc: New test.
    
    (cherry picked from commit d045eb13b0b42870a1f081895df3901112a358f0)

diff --git a/libstdc++-v3/include/bits/chrono.h b/libstdc++-v3/include/bits/chrono.h
index 0773867da71..a7157628a0a 100644
--- a/libstdc++-v3/include/bits/chrono.h
+++ b/libstdc++-v3/include/bits/chrono.h
@@ -1239,6 +1239,7 @@ _GLIBCXX_BEGIN_INLINE_ABI_NAMESPACE(_V2)
       now() noexcept;
 
       // Map to C API
+      [[__gnu__::__always_inline__]]
       static std::time_t
       to_time_t(const time_point& __t) noexcept
       {
@@ -1246,6 +1247,7 @@ _GLIBCXX_BEGIN_INLINE_ABI_NAMESPACE(_V2)
 			   (__t.time_since_epoch()).count());
       }
 
+      [[__gnu__::__always_inline__]]
       static time_point
       from_time_t(std::time_t __t) noexcept
       {
diff --git a/libstdc++-v3/testsuite/20_util/system_clock/99832.cc b/libstdc++-v3/testsuite/20_util/system_clock/99832.cc
new file mode 100644
index 00000000000..693d4d647d9
--- /dev/null
+++ b/libstdc++-v3/testsuite/20_util/system_clock/99832.cc
@@ -0,0 +1,14 @@
+// { dg-options "-O0 -g0" }
+// { dg-do compile { target c++20 } }
+// { dg-final { scan-assembler-not "system_clock9to_time_t" } }
+
+// Bug libstdc++/99832
+// std::chrono::system_clock::to_time_t needs ABI tag for 32-bit time_t
+
+#include <chrono>
+
+std::time_t
+test_pr99832(std::chrono::system_clock::time_point t)
+{
+  return std::chrono::system_clock::to_time_t(t);
+}

